-- GNU GENERAL PUBLIC LICENSE Version 3
-- Created by Monk3yDev 
-- I will be so happy when this addon become popular.
-- If you want use code from DestroyusPro
-- please let me know about it monk3ydev at gmail dot com 

DestroyusProMain = {}
DestroyusProMain.cif = _DPContainerItemApi()

DestroyusPro = DestroyusProApi()

local frame = CreateFrame("Frame", "DestroyusPro")
frame:RegisterEvent("ADDON_LOADED")

-- Milling --
local ClickMeForWorkMilling = CreateFrame("Button", "ClickMeForWorkMilling", UIParent, "SecureActionButtonTemplate")
ClickMeForWorkMilling:SetAttribute("type", "macro")
ClickMeForWorkMilling:SetAttribute("macrotext", "")
ClickMeForWorkMilling:RegisterEvent("PLAYER_REGEN_DISABLED")
ClickMeForWorkMilling:RegisterEvent("PLAYER_REGEN_ENABLED")

-- Disenchant --
local ClickMeForWorkDisenchanting = CreateFrame("Button", "ClickMeForWorkDisenchanting", UIParent, "SecureActionButtonTemplate")
ClickMeForWorkDisenchanting:SetAttribute("type", "macro")
ClickMeForWorkDisenchanting:SetAttribute("macrotext", "")
ClickMeForWorkDisenchanting:RegisterEvent("PLAYER_REGEN_DISABLED")
ClickMeForWorkDisenchanting:RegisterEvent("PLAYER_REGEN_ENABLED")

-- Prospecting --
local ClickMeForWorkProspecting = CreateFrame("Button", "ClickMeForWorkProspecting", UIParent, "SecureActionButtonTemplate")
ClickMeForWorkProspecting:SetAttribute("type", "macro")
ClickMeForWorkProspecting:SetAttribute("macrotext", "")
ClickMeForWorkProspecting:RegisterEvent("PLAYER_REGEN_DISABLED")
ClickMeForWorkProspecting:RegisterEvent("PLAYER_REGEN_ENABLED")

-- Mass Milling legion --
local ClickMeForWorkMassMillingLegion = CreateFrame("Button", "ClickMeForWorkMassMillingLegion", UIParent, "SecureActionButtonTemplate")
ClickMeForWorkMassMillingLegion:SetAttribute("type", "macro")
ClickMeForWorkMassMillingLegion:SetAttribute("macrotext", "")
ClickMeForWorkMassMillingLegion:RegisterEvent("PLAYER_REGEN_DISABLED")
ClickMeForWorkMassMillingLegion:RegisterEvent("PLAYER_REGEN_ENABLED")

DestroyusProMain.isInCombatMode = false -- change to local?

local function loadAddonData(self, event, arg1)
    if event == "ADDON_LOADED" and arg1 == 'DestroyusPro' then
		if _G["DestroyusProInitDataFirstLoad"] == nil then
			_G["DestroyusProInitDataFirstLoad"] = true
			_G["DestroyusProItemQualityValue"] = 2
			_G["DestroyusProPrintOutState"] = true
		end
		local msg = "DestroyusPro Addon sucessfuly loaded. Quiality of items %s"
	    print(msg:format(DestroyusProApi.numToStrQuality[_G["DestroyusProItemQualityValue"]]))
	end
end

local function combatMode(self, event, arg1)
	if event == "PLAYER_REGEN_DISABLED" then
		DestroyusProMain.isInCombatMode = true
	end
	if event == "PLAYER_REGEN_ENABLED" then
		DestroyusProMain.isInCombatMode = false
	end
end

local function preClickMacroButton(self, event)
	if DestroyusProMain.isInCombatMode == false then
		local result = DestroyusProMain.findItemToWork(_DPSpellApi.spellDisenchant)
		self:SetAttribute("macrotext", DestroyusProMain.createMacroUsage(_DPSpellApi.spellDisenchant, result)) --Disenchant
		DestroyusProMain.printResults(_DPSpellApi.spellDisenchant, result)
	end
end

local function preClickMacroButtonMilling(self, event)
	if DestroyusProMain.isInCombatMode == false then
		local result = DestroyusProMain.findItemToWork(_DPSpellApi.spellMilling)
		self:SetAttribute("macrotext", DestroyusProMain.createMacroUsage(_DPSpellApi.spellMilling , result)) -- Milling
		DestroyusProMain.printResults(_DPSpellApi.spellMilling , result)
	end
end

local function preClickMacroButtonProspecting(self, event)
	if DestroyusProMain.isInCombatMode == false then
		local result = DestroyusProMain.findItemToWork(_DPSpellApi.spellProspecting)
    	self:SetAttribute("macrotext", DestroyusProMain.createMacroUsage(_DPSpellApi.spellProspecting, result)) -- Prospecting
		DestroyusProMain.printResults(_DPSpellApi.spellProspecting, result)
	end
end

local function preClickMacroButtonMassMillingLegion(self, event)
	if DestroyusProMain.isInCombatMode == false then
		local result, spellForCast = DestroyusProMain.findItemToWorkMassMilling()
		self:SetAttribute("macrotext", DestroyusProMain.createMacroUsage(spellForCast, result)) -- Mass Milling Legion
		DestroyusProMain.printResults(spellForCast, result)
	end
end

local function postClickMacroButton(self, event)
	if DestroyusProMain.isInCombatMode == false then
		self:SetAttribute("macrotext", "")
	end
end

local function postClickMacroButtonMilling(self, event)
	if DestroyusProMain.isInCombatMode == false then
		self:SetAttribute("macrotext", "")
	end
end

local function postClickMacroButtonProspecting(self, event)
	if DestroyusProMain.isInCombatMode == false then
		self:SetAttribute("macrotext", "")
	end
end

local function postClickMacroButtonMassMillingLegion(self, event)
	if DestroyusProMain.isInCombatMode == false then
		self:SetAttribute("macrotext", "")
	end
end

frame:SetScript("OnEvent", loadAddonData)
-- Set protection to do not create macro in combat
ClickMeForWorkDisenchanting:SetScript("OnEvent", combatMode)
ClickMeForWorkMilling:SetScript("OnEvent", combatMode)
ClickMeForWorkProspecting:SetScript("OnEvent", combatMode)
ClickMeForWorkMassMillingLegion:SetScript("OnEvent", combatMode)

-- Create macro
ClickMeForWorkDisenchanting:SetScript("PreClick", preClickMacroButton)
ClickMeForWorkMilling:SetScript("PreClick", preClickMacroButtonMilling)
ClickMeForWorkProspecting:SetScript("PreClick", preClickMacroButtonProspecting)
ClickMeForWorkMassMillingLegion:SetScript("PreClick", preClickMacroButtonMassMillingLegion)

-- Clear macro
ClickMeForWorkDisenchanting:SetScript("PostClick", postClickMacroButton)
ClickMeForWorkMilling:SetScript("PostClick", postClickMacroButtonMilling)
ClickMeForWorkProspecting:SetScript("PostClick", postClickMacroButtonProspecting)
ClickMeForWorkMassMillingLegion:SetScript("PostClick", postClickMacroButtonMassMillingLegion)

function DestroyusProMain.isItemDisenchantableInBag(i, j)
	return DestroyusProMain.isItemDisenchantable(i, j)
end

function DestroyusProMain.isItemMillingableInBag(i, j)
	return DestroyusProMain.isItemMillingable(i, j)
end

function DestroyusProMain.isItemProspectingableInBag(i, j)
	return DestroyusProMain.isItemProspectingable(i, j)
end

-- Legion Mass Milling 
function DestroyusProMain.isAethrilMassMillingableInBag(i, j)
	return DestroyusProMain.isItemMassMillingable(i, j, 124101)
end

function DestroyusProMain.isDreamleafMassMillingableInBag(i, j)
	return DestroyusProMain.isItemMassMillingable(i, j, 124102)
end

function DestroyusProMain.isFelwortMillingableInBag(i, j)
	return DestroyusProMain.isItemMassMillingable(i, j, 124106)
end

function DestroyusProMain.isFjarnskagglMillingableInBag(i, j)
	return DestroyusProMain.isItemMassMillingable(i, j, 124104)
end

function DestroyusProMain.isFoxflowerMillingableInBag(i, j)
	return DestroyusProMain.isItemMassMillingable(i, j, 124103)
end

function DestroyusProMain.isStarlightRoseMillingableInBag(i, j)
	return DestroyusProMain.isItemMassMillingable(i, j, 124105)
end

function DestroyusProMain.isYserallineMillingableInBag(i, j)
	return DestroyusProMain.isItemMassMillingable(i, j, 128304)
end

DestroyusProMain.isItemProffesionInBag = {}
DestroyusProMain.isItemProffesionInBag[_DPSpellApi.spellDisenchant] = DestroyusProMain.isItemDisenchantableInBag
DestroyusProMain.isItemProffesionInBag[_DPSpellApi.spellMilling ] = DestroyusProMain.isItemMillingableInBag
DestroyusProMain.isItemProffesionInBag[_DPSpellApi.spellProspecting] = DestroyusProMain.isItemProspectingableInBag
-- Mass Milling Legion 
DestroyusProMain.isItemProffesionInBag[_DPSpellApi.spellMassMillAethril] = DestroyusProMain.isAethrilMassMillingableInBag
DestroyusProMain.isItemProffesionInBag[_DPSpellApi.spellMassMillDreamleaf] = DestroyusProMain.isDreamleafMassMillingableInBag
DestroyusProMain.isItemProffesionInBag[_DPSpellApi.spellMassMillFelwort] = DestroyusProMain.isFelwortMillingableInBag
DestroyusProMain.isItemProffesionInBag[_DPSpellApi.spellMassMillFjarnskaggl] = DestroyusProMain.isFjarnskagglMillingableInBag
DestroyusProMain.isItemProffesionInBag[_DPSpellApi.spellMassMillFoxflower] = DestroyusProMain.isFoxflowerMillingableInBag
DestroyusProMain.isItemProffesionInBag[_DPSpellApi.spellMassMillStarlightRose] = DestroyusProMain.isStarlightRoseMillingableInBag
DestroyusProMain.isItemProffesionInBag[_DPSpellApi.spellMassMillYserallineSeeds] = DestroyusProMain.isYserallineMillingableInBag

function DestroyusProMain.findItemToWork(proffesion)
    local result = {itemFound=false, i=0 ,j=0, link=""}
	for i=0,4 do 
		for j=1,GetContainerNumSlots(i) do 
			if DestroyusProMain.isItemProffesionInBag[proffesion](i,j) then
				DestroyusProMain.cif:setItemPos(i, j)
				result["itemFound"] = true
				result["i"] = i
				result["j"] = j
				result["link"] = DestroyusProMain.cif:getLink()
				break
			end 
		end 
	end
	return result
end


-- Create macro string for profession 
function DestroyusProMain.createMacroUsage(spell_id, result)
	local macroStr = ""
	if result["itemFound"] then
		local spellName = _DPSpellApi(spell_id):getSpellName()
	    macroStr = '/cast '.. spellName ..'\n/use %d %d'
		macroStr = macroStr:format(result["i"], result["j"])
	end
	return macroStr
end

-- Print results of the destroyed item from the bag
function DestroyusProMain.printResults(spell_id, result)
	local spellName = _DPSpellApi(spell_id):getSpellName()
	if result["itemFound"] then
		if _G["DestroyusProPrintOutState"] ~= false then
			print("".. spellName .." => " .. result["link"])
		end
	else
		local msg = ""
		if spell_id == _DPSpellApi.spellDisenchant then 
			msg = string.format("Quiality of items %s", DestroyusProApi.numToStrQuality[_G["DestroyusProItemQualityValue"]])
		end
		print(string.format("Nothing to %s! %s", spellName, msg))
	end
end

function DestroyusProMain.isItemDisenchantable(i, j)
	return DestroyusPro:isItemDisenchantable(i, j)
end

function DestroyusProMain.isItemMillingable(i, j)
	return DestroyusPro:isItemMillingable(i, j)
end

function DestroyusProMain.isItemProspectingable(i, j)
	return DestroyusPro:isItemProspectingable(i, j)
end

function DestroyusProMain.isItemMassMillingable(i, j, herb_id)
	return DestroyusPro:isItemMassMillingable(i, j, herb_id)
end

function DestroyusProMain.collectMassMillingSpell()
	local collectedSpells = {}
	for _, spell_id in ipairs(DestroyusProMain.spellsToFindMassMillLegion) do
		if _DPSpellApi(spell_id):isInSpellBook() == true then
			table.insert(collectedSpells, spell_id)
		end
	end
	return collectedSpells
end

function DestroyusProMain.findItemToWorkMassMilling()
	local collectedSpells = DestroyusProMain.collectMassMillingSpell()
	local result = {itemFound=false, i=0 ,j=0, link=""}
	local spellForCast = _DPSpellApi.spellMilling  -- Default Message Nothing to Milling
	for _, spell_id in ipairs(collectedSpells) do
		result = DestroyusProMain.findItemToWork(spell_id)
		if result["itemFound"] == true then
			spellForCast = spell_id
			break
		end
	end
	return result, spellForCast
end

DestroyusProMain.spellsToFindMassMillLegion = {_DPSpellApi.spellMassMillAethril,
	_DPSpellApi.spellMassMillDreamleaf,
	_DPSpellApi.spellMassMillFelwort,
	_DPSpellApi.spellMassMillFjarnskaggl,
	_DPSpellApi.spellMassMillFoxflower,
	_DPSpellApi.spellMassMillStarlightRose,
	_DPSpellApi.spellMassMillYserallineSeeds}