local ASCII_0_NUMBER = 48
local ASCII_9_NUMBER = 57
SLASH_DISENCH1 = '/disenchantus' --disenchantus
SLASH_MILLINGUS1 = '/millingus'  --millingus
SLASH_PROSPECTINGUS1 = '/prospectingus'  --prospectingus
SLASH_DESTROYUSPRO1 = '/destroyuspro'  --destroyuspro

local function changeQualityDisenchanting(quality)
	_G["DestroyusProItemQualityValue"] = DestroyusProApi.strToNumQuality[quality]
	ReloadUI()
end

local function unknownCommand(command)
    if command == nil then
		command = ""
	end
	local commandMsg = "Uknown value for the command: %s" -- TODO Tanslate
	print(commandMsg:format(command))
end

local function createMacroDisenchanting()
	if GetMacroInfo("Disenchantus") == nil then
		CreateMacro("Disenchantus", "645142", "/click ClickMeForWorkDisenchanting")
		ReloadUI()
	else
		print("Macro with the name 'Disenchantus' already exists. Check body macro if have same syntax: \n" ..
	      "/click ClickMeForWorkDisenchanting")
	end
end

local function createMacroMiling()
	if GetMacroInfo("Millingus") == nil then
		CreateMacro("Millingus", "237031", "/click ClickMeForWorkMilling")
		ReloadUI()
	else
		print("Macro with the name 'Millingus' already exists. Check body macro if have same syntax: \n" ..
	      "/click ClickMeForWorkMilling")
	end
end

local function createMacroProspecting()
	if GetMacroInfo("Prospectingus") == nil then
		CreateMacro("Prospectingus", "133287", "/click ClickMeForWorkProspecting")
		ReloadUI()
	else
		print("Macro with the name 'Prospectingus' already exists. Check body macro if have same syntax: \n" ..
	      "/click ClickMeForWorkProspecting")
	end
end

local function createMacroMassMilingLegion()
	if GetMacroInfo("MassMillingus") == nil then
		CreateMacro("MassMillingus", "237032", "/click ClickMeForWorkMassMillingLegion")
		ReloadUI()
	else
		print("Macro with the name 'MassMillingus' already exists. Check body macro if have same syntax: \n" ..
	      "/click ClickMeForWorkMassMillingLegion")
	end
end

local function changeStateForPrintout(msg)
	if msg == "offinfo" then
		_G["DestroyusProPrintOutState"] = false
	end
	if msg == "oninfo" then
		_G["DestroyusProPrintOutState"] = true
	end
	ReloadUI()
end

commandsDisenchanting = {}
commandsDisenchanting["uncommon"] = changeQualityDisenchanting
commandsDisenchanting["rare"] = changeQualityDisenchanting
commandsDisenchanting["epic"] = changeQualityDisenchanting
commandsDisenchanting["macro"] = createMacroDisenchanting

-- Quick fix for the transalting TODO
commandsDisenchanting["2"] = changeQualityDisenchanting
commandsDisenchanting["3"] = changeQualityDisenchanting
commandsDisenchanting["4"] = changeQualityDisenchanting
-- end


commandsMilling = {}
commandsMilling["macro"] = createMacroMiling
commandsMilling["macrolegion"] = createMacroMassMilingLegion

commandsProspecting = {}
commandsProspecting["macro"] = createMacroProspecting

commandsDestroyusPro = {}
commandsDestroyusPro["offinfo"] = changeStateForPrintout
commandsDestroyusPro["oninfo"] = changeStateForPrintout

ExtraTabFun.setDefault(commandsDisenchanting, unknownCommand)
ExtraTabFun.setDefault(commandsMilling, unknownCommand)
ExtraTabFun.setDefault(commandsProspecting, unknownCommand)
ExtraTabFun.setDefault(commandsDestroyusPro, unknownCommand)

local function commandHandler(msg, editBox)
	commandsDisenchanting[msg](msg)
end

local function commandHandlerMilling(msg, editBox)
	commandsMilling[msg](msg)
end

local function commandHandlerProspecting(msg, editBox)
	commandsProspecting[msg](msg)
end

local function commandHandlerDestroyusPro(msg, editBox)
	commandsDestroyusPro[msg](msg)
end

SlashCmdList["DISENCH"] = commandHandler
SlashCmdList["MILLINGUS"] = commandHandlerMilling
SlashCmdList["PROSPECTINGUS"] = commandHandlerProspecting
SlashCmdList["DESTROYUSPRO"] = commandHandlerDestroyusPro